#ifndef __IUF_GAMESESSION
#define __IUF_GAMESESSION

#include <vcg/Point3.h>
#include <list>
#include "GameObj.h"
#include "Bullet.h"
#include "Ast.h"
#include "Ship.h"

/** This class represent Game session.
It contain all the data needed during the game play, 
active game objects, score, lives and so on.
*/
using namespace vcg;
using namespace std;
class GameSession
{
 public:

	 GameSession()
	 {
		 SpaceSize=100;
	 }

 /** The list of all the active bullets
 @type list<Bullet *> */
	 list<Bullet *> ActiveBullet;
 
 /** The list of all the active Asteroid 
 @type list<Ast*> */
	 list<Ast *> ActiveAst;
 
 /** The list of all the generic active objects 
 @type list<GameObj *> */
	 list<GameObj *> ActiveObj;
 
  /// The only Spaceship in game.
  Ship *S;
 
	/// This function updates All the active objects
 	void Update(int dt);
 
  /// This function draws all the active objects
  void Draw();
 
  /// This function clip the position of an object against the screen boundary
  void Clip(Point3f &p)
  {
	 if(p.x() > SpaceSize) p.x() -=2*SpaceSize; 
   if(p.y() > SpaceSize) p.y() -=2*SpaceSize; 
   if(p.x() <-SpaceSize) p.x() +=2*SpaceSize; 
   if(p.y() <-SpaceSize) p.y() +=2*SpaceSize; 
 };
 
 /// This function Check ALL the possible collisions
 void CheckCollisions();
 
 /** Shoot a bullet.
 What kind of bullet is shot depends on the current type of 
 ship stored in member S;
 */
 void Shoot();

 
 /// Start the game
 void Start();
 
 /// Pause the game
 void Pause ();

 /// Game Over;
 void End();

 /// Screen Width
 int ScreenW;
 /// Screen Height
 int ScreenH;
 ///The size of the Game Space (in mt)
 int SpaceSize;
};

#endif // ifndef __IUF_GAMESESSION